Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class fTop
	Inherits System.Windows.Forms.Form

       Private TestSequenceByte As Integer = 0

    Private Sub bRun_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bRun.Click
        Dim x As Integer
        Dim j As Integer
        Dim sStr As String = ""
        On Error GoTo badport91
        If commPort.IsOpen() = False Then
            MsgBox("Need to open COM port first.")
            Exit Sub
        End If
        On Error Resume Next
        If RunMode = True Then
            Add_Text("Already in RUN mode!")
        Else
            XmitMask = XmitMask Or XMIT_RUN
        End If
        Exit Sub
badport91:
        On Error Resume Next
        Add_Text("The port is not accessible at this time.")
        Exit Sub
    End Sub

    Private Sub fTop_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        On Error GoTo nogood
        If logging = True Then
            logging = False
            FileClose(2)
        End If
nogood:
        On Error Resume Next
        Quit = True
        ExitTimer.Enabled = True
    End Sub
    Private Sub bBtn1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bBtn1.Click
        fConfigure.Show()
        fConfigure.BringToFront()
        fConfigure.Focus()
    End Sub

    Private Sub bBtn2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bBtn2.Click
        fMsgWindow.Show()
        fMsgWindow.BringToFront()
        fMsgWindow.Focus()
    End Sub

    Private Sub bBtn3_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bBtn3.Click
        Dim sStr2 As String
        Dim i As Short
        Dim j As Short
        On Error GoTo badport92
        If commPort.IsOpen() = False Then
            MsgBox("Need to open COM port first.")
            Exit Sub
        End If
        If TestMode = True Then
            If XmitTestSequence = True Then
                XmitTestSequence = False
                bBtn3.Text = "Send Test Sequence"
            Else
                If commPort.DsrHolding = False Then
                    MsgBox("Need to enter RUN mode first.")
                Else
                    XmitTestSequence = True
                    bBtn3.Text = "Stop Test Sequence"
                End If
            End If
            Exit Sub
        Else
            If Selected_Message < 1 Then
                MsgBox("No message selected.")
                Exit Sub
            End If
            bBtn3.Enabled = False
            On Error GoTo errread
            FileOpen(1, My.Application.Info.DirectoryPath & "\KWP2000.MSG", OpenMode.Input)
            On Error GoTo notthere
            For i = 1 To Selected_Message
                Input(1, sStr)
            Next i
            FileClose(1)
            On Error Resume Next
            If RunMode = False Then
                MsgBox("Need to enter RUN mode first.")
            Else
                Add_Text(("TX: " & sStr))
                j = 0 : sStr2 = ""
                For i = 1 To Len(sStr) Step 3
                    HexToChar((Mid(sStr, i, 2)))
                    While commPort.CtsHolding = False And Quit = False
                        System.Windows.Forms.Application.DoEvents()
                    End While
                    If Quit = True Then Exit Sub
                    commPort.Write(Chr(HexNum))
                    While commPort.BytesToWrite > 0 And Quit = False And commPort.CtsHolding = True
                        System.Windows.Forms.Application.DoEvents()
                    End While
                    If Quit = True Then Exit Sub
                Next i
            End If
        End If
        bBtn3.Enabled = True
        Exit Sub
errread:
        On Error Resume Next
        MsgBox("Error reading " & My.Application.Info.DirectoryPath & "\KWP2000.MSG!")
        FileClose(1)
        bBtn3.Enabled = True
        Exit Sub
notthere:
        On Error Resume Next
        MsgBox("Undefined selected message!")
        FileClose(1)
        bBtn3.Enabled = True
        Exit Sub
badport92:
        On Error Resume Next
        Add_Text("The port is not accessible at this time.")
        bBtn3.Enabled = True
        Exit Sub
    End Sub

    Private Sub bBtn4_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bBtn4.Click
        tTerminalWindow.Text = ""
    End Sub

    Private Sub bBtn5_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bBtn5.Click
        fTesterPresentMsg.Show()
        fTesterPresentMsg.BringToFront()
        fTesterPresentMsg.Focus()
    End Sub
    Private Sub bBtn6_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bBtn6.Click
        Dim j As Short
        Dim x As Short
        Dim mode As String
        On Error GoTo badport93
        If commPort.IsOpen() = False Then
            MsgBox("Need to open COM port first.")
            Exit Sub
        End If
        bBtn6.Enabled = False
        commPort.DtrEnable = False
        DSRwait = True
        If commPort.DsrHolding = True Then
            Add_Text("Exiting RUN mode to send init...")
            While commPort.DsrHolding = True And Quit = False
                System.Windows.Forms.Application.DoEvents()
            End While
        End If
        RunMode = False
        If (PulseFast = True) Then
            Add_Text("TX Pulse Init")
            FastInitArguments = Chr(Int(PulseFastAmount / 256)) + Chr(PulseFastAmount And 255)
            XmitMask = XmitMask Or XMIT_PULSE_INIT
        Else
            If Functional Then
                If AlternateMethod = True Then
                    mode = "f"
                Else
                    mode = "F"
                End If
            Else
                If AlternateMethod = True Then
                    mode = "p"
                Else
                    mode = "P"
                End If
            End If
            If FastInit Then
                FastInitArguments = mode & Chr(Source_Address) & Chr(Target_Address)
                XmitMask = XmitMask Or XMIT_FAST_INIT
            Else
                SlowInitArguments = mode & Chr(Source_Address) & Chr(Target_Address)
                XmitMask = XmitMask Or XMIT_SLOW_INIT
            End If
        End If
        bBtn6.Enabled = True
        TestRecvStarted = False
        DSRwait = False
        Exit Sub
badport93:
        On Error Resume Next
        Add_Text("The port is not accessible at this time.")
        Exit Sub
    End Sub

    Private Sub bBtn7_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bBtn7.Click
        On Error GoTo badport94
        Dim counts As Integer
        If commPort.IsOpen() = False Then
            MsgBox("Need to open COM port first.")
            Exit Sub
        End If
        commPort.DtrEnable = False
        DSRwait = True
        If commPort.DsrHolding = True Then
            Add_Text("Exiting RUN mode to query status...")
            counts = HundredMsec
            While commPort.DsrHolding = True And Quit = False And _
                ((HundredMsec - counts) >= 0) And ((HundredMsec - counts) < 50)
                System.Windows.Forms.Application.DoEvents()
            End While
        End If
        If commPort.DsrHolding = False Then
            If RunMode = RunMode Then
                RunMode = False
                If Quit = False Then
                    SendQuery = True
                End If
            End If
            DSRwait = False
        Else
            Add_Text("Failed to exit RUN mode.")
        End If
        Exit Sub
badport94:
        On Error Resume Next
        Add_Text("The port is not accessible at this time.")
        Exit Sub
    End Sub

    Private Sub bBtn8_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bBtn8.Click
        On Error GoTo badport95
        If commPort.IsOpen() = False Then
            MsgBox("Need to open COM port first.")
            Exit Sub
        End If
        commPort.DtrEnable = False
        DSRwait = True
        If commPort.DsrHolding = True Then
            Add_Text("Exiting RUN mode to clear buffers...")
            While commPort.DsrHolding = True And Quit = False
                System.Windows.Forms.Application.DoEvents()
            End While
        End If
        RunMode = False
        'Retries = 0
resendx:
        XmitMask = XmitMask Or XMIT_CLEAR
        DSRwait = False
        Exit Sub
badport95:
        On Error Resume Next
        Add_Text("The port is not accessible at this time.")
        Exit Sub
    End Sub

    Private Sub bBtn9_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bBtn9.Click
        On Error GoTo badport96
        If commPort.IsOpen() = False Then
            MsgBox("Need to open COM port first.")
            Exit Sub
        End If
        commPort.DtrEnable = False
        DSRwait = True
        If commPort.DsrHolding = True Then
            Add_Text("Exiting RUN mode to query keyword...")
            While commPort.DsrHolding = True And Quit = False
                System.Windows.Forms.Application.DoEvents()
            End While
        End If
        RunMode = False
        Get_Keyword((False))
        DSRwait = False
        Exit Sub
badport96:
        On Error Resume Next
        Add_Text("The port is not accessible at this time.")
        Exit Sub
    End Sub

    Private Sub fTop_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim i As Short
        If Quit = True Then
            Exit Sub
        End If
        Me.Hide()
        'UPGRADE_ISSUE: App property App.PrevInstance was not upgraded. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="076C26E5-B7A9-4E77-B69C-B4448DF39E58"'
        'If App.PrevInstance Then
        ' MsgBox("Already Running")
        'End
        'End If
        fTopForm = Me
        inAddText = False
        TestRecvStarted = False
        RunMode = False
        SendQuery = False
        in_Timer2 = False
        VoltageSelectionChanged = False
        AlternateMethod = False
        RecvState = 0
        TimeVal = 2
        frmSplash.Show()
        frmSplash.BringToFront()
        frmSplash.Refresh()
        Loaded = False
        TestMode = False
        BaudRate = 10400
        InterByteDelay = 5
        SendHeader = "14230"
        tTerminalWindow.Text = ""
        For i = 0 To 255
            Try
                If fTopForm.commPort.IsOpen() = True Then
                    fTopForm.commPort.Close()
                End If
                fTopForm.commPort.PortName = "COM" + VB6.Format(i, "#0")
                fTopForm.commPort.Open()
                fTopForm.commPort.Close()
                goodport(i) = True
            Catch
                goodport(i) = False
            End Try
        Next i
        Try
            FileOpen(1, My.Application.Info.DirectoryPath & "\KWP2000.CFG", OpenMode.Input)
            Input(1, sStr)
            commPort.PortName = sStr
            Input(1, sStr)
            If Val(sStr) >= 1 Then
                FastInit = True
            Else
                FastInit = False
            End If
            Input(1, sStr)
            Selected_Message = Val(sStr)
            Input(1, sStr)
            Source_Address = Val(sStr)
            Input(1, sStr)
            Target_Address = Val(sStr)
            Input(1, sStr)
            If Val(sStr) >= 1 Then
                TesterPresent = True
            Else
                TesterPresent = False
            End If
            Input(1, sStr)
            If Val(sStr) >= 1 Then
                CustomTesterPresent = True
                bBtn5.Enabled = True
            Else
                CustomTesterPresent = False
                bBtn5.Enabled = False
            End If
            Input(1, sStr)
            Tester_Present_Message = Val(sStr)
            Input(1, sStr)
            Voltage_Selection = Val(sStr)
            Input(1, sStr)
            If Val(sStr) >= 1 Then
                Functional = True
            Else
                Functional = False
            End If
            Input(1, sStr)
            BaudRate = Val(sStr)
            If BaudRate < 1000 Then
                BaudRate = 10400
            End If
            If BaudRate > 115200 Then
                BaudRate = 115200
            End If
            Input(1, sStr)
            InterByteDelay = Val(sStr)
            If InterByteDelay < 0 Or InterByteDelay > 51 Then
                InterByteDelay = 5
            End If
            Input(1, sStr)
            If Val(sStr) > 0 Then
                AlternateMethod = True
            Else
                AlternateMethod = False
            End If
            Input(1, sStr)
            If Val(sStr) > 0 Then
                PulseFast = True
            Else
                PulseFast = False
            End If
            Input(1, sStr)
            PulseFastAmount = Val(sStr)
            FileClose(1)
        Catch
            commPort.PortName = "COM1"
            FastInit = True
            Selected_Message = 1
            Source_Address = 0
            Target_Address = 0
        End Try
        Loaded = True
        BaudRateChanged = True
        VoltageSelectionChanged = True
        InterByteChanged = True
        Retries = 0
        PulseFast = False
        PulseFastAmount = 1
        '        Try
        'fTopForm.commPort.Open()
        'If commPort.DsrHolding = False Then
        ''make sure to set DTR false
        ''or the ISO-14230 box will
        ''not listen to us while it
        ''is de-asserting DSR
        'commPort.DtrEnable = False
        'If commPort.CtsHolding = True Then
        ' Retries = 0
sendit:  ' System.Windows.Forms.Application.DoEvents()
        ' System.Windows.Forms.Application.DoEvents()
        ' System.Windows.Forms.Application.DoEvents()
        ' System.Windows.Forms.Application.DoEvents()
        ' System.Windows.Forms.Application.DoEvents()
        ' commPort.DiscardInBuffer() 'clear rx buf'
        ' If commPort.DsrHolding = True Then
        ' GoTo alreadyrun
        ' End If
        ' XmitMask = XmitMask Or XMIT_REVISION
        ' System.Windows.Forms.Application.DoEvents()
sendit2:
sendit3:
        'If commPort.DsrHolding = True Then
        ' GoTo alreadyrun
        ' End If
        ' XmitMask = XmitMask Or XMIT_STATUS
        ' Else
        ' Timestamp = HundredMsec
        ' System.Windows.Forms.Application.DoEvents()
        ' While ((HundredMsec - Timestamp < 5) And (HundredMsec - Timestamp >= 0))
        ' If commPort.CtsHolding = True Then
        ' GoTo sendit
        ' End If
        ' System.Windows.Forms.Application.DoEvents()
        ' End While
        ' Add_Text(("ISO-14230 Box is not connected!"))
        ' SendQuery = False
        ' GoTo donewiththis
        ' End If
gotone:
        'Else
alreadyrun:
        'Add_Text(("ISO-14230 Box is Already in RUN Mode!"))
        'RunMode = True
        'commPort.DtrEnable = True
        'End If
donewiththis:
        'Catch
        ' MsgBox("Could not initialize COM port!")
        ' Exit Sub
        ' End Try
backtomain2:
        If (AlternateMethod = True And FastInit = False) Then
            Timer1.Interval = FAST_INTERVAL
        Else
            Timer1.Interval = 2000
        End If
        While TimeVal > 0
            System.Windows.Forms.Application.DoEvents()
        End While
        Quit = False
        Me.Show()
        Me.BringToFront()
        Exit Sub
    End Sub


    Private Sub fTop_Resize(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Resize
        If VB6.PixelsToTwipsX(Me.Width) > 350 Then
            tTerminalWindow.Width = VB6.TwipsToPixelsX(VB6.PixelsToTwipsX(Me.Width) - 330)
        End If
        If VB6.PixelsToTwipsY(Me.Height) > 4800 Then
            tTerminalWindow.Height = VB6.TwipsToPixelsY(VB6.PixelsToTwipsY(Me.Height) - 4550)
        End If
    End Sub

    Private Sub Form_Terminate_Renamed()
        Quit = True
        If logging = True Then
            logging = False
            FileClose(3)
        End If
        End
    End Sub

    Private Sub ExitTimer_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ExitTimer.Tick
        Form_Terminate_Renamed()
    End Sub

    Private Sub Timer2_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer2.Tick
        Dim recvStr As String
        Dim buildStr As String
        Dim hexstr As String
        Dim Buffer(1024) As Byte
        Dim i As Short
        Dim br As Integer
        If HundredMsec < 32767 Then
            HundredMsec = HundredMsec + 1
        Else
            HundredMsec = 0
        End If
        If inAddText = True Or Quit = True Or in_Timer2 = True Then
            Exit Sub
        End If
        On Error GoTo badport
        If commPort.IsOpen() = False Then
            Exit Sub
        End If
        in_Timer2 = True
        If XmitTestSequence = True And TestMode = True And _
            fTopForm.commPort.CtsHolding = True And _
            fTopForm.commPort.DtrEnable = True And _
            fTopForm.commPort.DsrHolding = True And Quit = False And _
            fTopForm.commPort.BytesToWrite = 0 Then
            For i = 1 To 256
                If fTopForm.commPort.CtsHolding = False Then
                    Exit For
                End If
                If fTopForm.commPort.DsrHolding = False Then
                    Exit For
                End If
                TestSequenceByte = TestSequenceByte + 1
                TestSequenceByte = TestSequenceByte And 255
                buildStr = Chr(TestSequenceByte)
                fTopForm.commPort.Write(buildStr)
                If TestSequenceByte = 0 Then
                    Add_Text("TX: 256 bytes in order")
                End If
            Next i
        End If
        If Waiting = False And XmitMask <> 0 Then
            Waiting = True
            If XmitMask And XMIT_STATUS Then
                ResponseWaitTime = 25
                RecvExpectedLen = 1
                RecvExpected = XMIT_STATUS
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_STATUS)
                Add_Text("TX: Requesting Status")
                Send_Message(("?"))
            ElseIf XmitMask And XMIT_REVISION Then
                Add_Text("TX: Requesting Revision")
                ResponseWaitTime = 25
                RecvExpectedLen = 1
                RecvExpected = XMIT_REVISION
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_REVISION)
                Send_Message(("R"))
            ElseIf XmitMask And XMIT_RUN Then
                Add_Text("TX: Requesting RUN Mode")
                ResponseWaitTime = 15 * 7
                RecvExpectedLen = 1
                RecvExpected = XMIT_RUN
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_RUN)
                Send_Message(("G"))
            ElseIf XmitMask And XMIT_FAST_INIT Then
                Add_Text("TX: Fast Init")
                ResponseWaitTime = ((15 + ((InterByteDelay) / 10)) * 3)
                RecvExpectedLen = 1
                RecvExpected = XMIT_FAST_INIT
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_FAST_INIT)
                Send_Message((("F" & FastInitArguments)))
            ElseIf XmitMask And XMIT_SLOW_INIT Then
                Add_Text("TX: Slow Init")
                ResponseWaitTime = 100
                RecvExpectedLen = 1
                RecvExpected = XMIT_SLOW_INIT
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_SLOW_INIT)
                Send_Message(("5" & SlowInitArguments))
            ElseIf XmitMask And XMIT_CLEAR Then
                If InvisibleClear = False Then
                    Add_Text("TX: Clear Buffers")
                    ResponseWaitTime = 25
                Else
                    ResponseWaitTime = 250
                End If
                RecvExpectedLen = 1
                RecvExpected = XMIT_CLEAR
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_CLEAR)
                Send_Message(("X"))
            ElseIf XmitMask And XMIT_KEYWORD Then
                Add_Text("TX: Request Keyword")
                ResponseWaitTime = 25
                RecvExpectedLen = 2
                RecvExpected = XMIT_KEYWORD
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_KEYWORD)
                Send_Message(("K"))
            ElseIf XmitMask And XMIT_BAUD Then
                Add_Text("TX: Set Baud Rate")
                ResponseWaitTime = 25
                RecvExpectedLen = 1
                RecvExpected = XMIT_BAUD
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_BAUD)
                Send_Message(("B" & BaudArguments))
            ElseIf XmitMask And XMIT_INTERBYTE Then
                Add_Text("TX: Set Interbyte Delay")
                ResponseWaitTime = 25
                RecvExpectedLen = 1
                RecvExpected = XMIT_INTERBYTE
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_INTERBYTE)
                Send_Message(("I" & InterbyteArguments))
            ElseIf XmitMask And XMIT_VOLTAGE Then
                Add_Text("TX: Set Voltage Selection")
                ResponseWaitTime = 25
                RecvExpectedLen = 1
                RecvExpected = XMIT_VOLTAGE
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_VOLTAGE)
                Send_Message(("V" & VoltageArguments))
            ElseIf XmitMask And XMIT_SYSTEM_ID Then
                Add_Text("TX: Request System ID")
                ResponseWaitTime = 25
                RecvExpectedLen = 2
                RecvExpected = XMIT_SYSTEM_ID
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_SYSTEM_ID)
                Send_Message(("Z"))
            ElseIf XmitMask And XMIT_PULSE_INIT Then
                Add_Text("TX: Pulse Init")
                ResponseWaitTime = 15 + (PulseFastAmount / 100)
                RecvExpectedLen = 1
                RecvExpected = XMIT_PULSE_INIT
                XmitMask = XmitMask And (&HFFFFFFFF - XMIT_PULSE_INIT)
                Send_Message(("f" & FastInitArguments))
            Else
                Waiting = False
            End If
        ElseIf Waiting = True Then
            If ResponseWaitTime = 0 Then
                If InvisibleClear <> True Then
                    Add_Text("ISO-14230 Box Not Responding.")
                End If
                Waiting = False
            Else
                ResponseWaitTime = ResponseWaitTime - 1
            End If
        End If
        If commPort.DtrEnable = True And commPort.DsrHolding = False And bRun.Enabled = True Then
backtoinit:
            Add_Text(("Going back to init mode..."))
            RunMode = False
            commPort.DtrEnable = False
            If TestMode = True Then
                TestRecvStarted = False
            End If
            SendQuery = True
            commPort.DiscardInBuffer() 'clear rx buf
            While commPort.DsrHolding = True And Quit = False
                System.Windows.Forms.Application.DoEvents()
                commPort.DiscardInBuffer()
            End While
            commPort.DiscardInBuffer()
        End If
        br = commPort.BytesToRead
        If (br > 0) Then
            If (br > 1023) Then
                br = 1023
            End If
            Buffer(br) = 0
            commPort.Read(Buffer, 0, br)
            recvStr = ""
            For i = 1 To br
                recvStr = recvStr + Chr(Buffer(i - 1))
            Next
        Else
            recvStr = ""
        End If
        If Len(recvStr) >= commPort.ReadBufferSize Then
            Add_Text(("PC RX Buffer Overflow"))
            GoTo backtoinit
        End If
        If Len(recvStr) > 0 Then
            RecvDataStamp = HundredMsec
            If RunMode Then
                If TestMode Then
                    System.Windows.Forms.Application.DoEvents()
                    While Len(recvStr) > 0
                        'DoEvents
                        If TestRecvStarted Then
                            If Asc(VB.Left(recvStr, 1)) = TestChar Then
                                If TestChar < 255 Then
                                    TestChar = TestChar + 1
                                Else
                                    Add_Text(("RX: 256 bytes in order (test mode)"))
                                    TestChar = 0
                                End If
                            Else
                                Add_Text(("RX: " & Hex(Asc(VB.Left(recvStr, 1))) & " Expected " & Hex(TestChar) & " (test mode error!)"))
                                GoTo backtoinit
                            End If
                        Else
                            TestRecvStarted = True
                            TestChar = Asc(VB.Left(recvStr, 1))
                            If TestChar < 255 Then
                                TestChar = TestChar + 1
                            Else
                                TestChar = 0
                            End If
                        End If
                        If Len(recvStr) > 1 Then
                            recvStr = VB.Right(recvStr, Len(recvStr) - 1)
                        Else
                            recvStr = ""
                        End If
                    End While
                Else
                    buildStr = "RX:"
                    For i = 1 To Len(recvStr)
                        hexstr = Hex(Asc(Mid(recvStr, i, 1)))
                        While Len(hexstr) < 2
                            hexstr = "0" & hexstr
                        End While
                        buildStr = buildStr & " " & hexstr
                    Next i
                    Add_Text((buildStr))
                End If
            Else
                ProcessInitMode(recvStr)
            End If
        End If
badport:
        On Error Resume Next
        in_Timer2 = False
    End Sub

    Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
        Dim i As Short
        Dim x As Short
        Dim sStr As String = ""
        Dim Retries As Short
        If Quit = True Then Exit Sub
        If Waiting = True Then
            Exit Sub
        End If
        On Error GoTo badport
        If commPort.IsOpen = False Then
            Exit Sub
        End If
        If commPort.CtsHolding = False Then Exit Sub
        If RunMode = False And SendQuery = True And Me.commPort.IsOpen() = True Then
            SendQuery = False
            XmitMask = XmitMask Or XMIT_REVISION
            XmitMask = XmitMask Or XMIT_STATUS
        End If
        If RunMode = True Then
            If commPort.DsrHolding = False Then
                RunMode = False
            Else
                If SendQuery = True Or BaudRateChanged = True Or _
                    InterByteChanged = True Or _
                    VoltageSelectionChanged = True Then
                    If commPort.DtrEnable = True Then
                        Add_Text("Going back to Init mode...")
                        commPort.DtrEnable = False
                    End If
                End If
            End If
        End If
        If BaudRateChanged = True And RunMode = False And Quit = False Then
            BaudRateChanged = False
            If (BaudRate <= 10417) Then
                sStr = Chr((Int(BaudRate / 256)) And 255)
                sStr = sStr & Chr(BaudRate And 255)
                Retries = 0
Resend00:
                If Quit = True Then Exit Sub
                If commPort.CtsHolding = False Then Exit Sub
                If commPort.DsrHolding = True Then 'user went quickly into
                    GoTo resumepast200    'run mode, so skip this
                End If                    'init mode command
                BaudArguments = sStr
                XmitMask = XmitMask Or XMIT_BAUD
            End If
        End If
resumepast200:
        If commPort.CtsHolding = False Then Exit Sub
        If Quit = True Then Exit Sub
        If InterByteChanged = True And RunMode = False And Quit = False Then
            InterByteChanged = False
            sStr = Chr(InterByteDelay)
            Retries = 0
Resend2001:
            If Quit = True Then Exit Sub
            If commPort.CtsHolding = False Then Exit Sub
            If commPort.DsrHolding = True Then 'user went quickly into
                GoTo resumepast2001   'run mode, so skip this
            End If                    'init mode command
            InterbyteArguments = sStr
            XmitMask = XmitMask Or XMIT_INTERBYTE
        End If
resumepast2001:
        If Quit = True Then Exit Sub
        If commPort.CtsHolding = False Then Exit Sub
        If VoltageSelectionChanged And RunMode = False And Quit = False Then
            VoltageSelectionChanged = False
            If Voltage_Selection = 1 Then
                sStr = Chr(0)
            Else
                If Voltage_Selection = 2 Then
                    sStr = Chr(12)
                Else
                    If Voltage_Selection = 3 Then
                        sStr = Chr(24)
                    Else
                        sStr = Chr(0)
                    End If
                End If
            End If
            If commPort.CtsHolding = False Then Exit Sub
            If Quit = True Then Exit Sub
            If commPort.DsrHolding = True Then 'user went quickly into
                GoTo resumepast2      'run mode, so skip this
            End If                    'init mode command
            VoltageArguments = sStr
            XmitMask = XmitMask Or XMIT_VOLTAGE
        End If
resumepast2:
        If Quit = True Then Exit Sub
        If commPort.CtsHolding = False Then Exit Sub
        SendTesterPresent()
        Exit Sub
badport:
        On Error Resume Next
        x = 0
        Exit Sub
    End Sub
    Public Sub SendTesterPresent()
        Dim x As Integer
        Dim i As Integer
        Dim sendstr As String
        If TesterPresent = True And Loaded And RunMode And Quit = False And Waiting = False And _
            commPort.DtrEnable = True And commPort.DsrHolding = True Then
            If InMiddleOfMessage = False And _
                (((HundredMsec - RecvDataStamp) >= 1) And _
                (AlternateMethod = True) And _
                (FastInit = False) And (PulseFast = False)) Or _
                (((HundredMsec - RecvDataStamp) >= 10) Or _
                ((HundredMsec - RecvDataStamp) < 0)) Then
                RecvDataStamp = HundredMsec
                If CustomTesterPresent = True And TesterPresent = True Then
                    If Tester_Present_Message < 1 Then
                        Exit Sub
                    End If
                    If commPort.IsOpen = False Then
                        Exit Sub
                    End If
                    On Error GoTo errread
                    FileOpen(1, My.Application.Info.DirectoryPath & "\KWP2000.MSG", OpenMode.Input)
                    On Error GoTo notthere
                    For i = 1 To Tester_Present_Message
                        Input(1, sStr)
                    Next i
                    FileClose(1)
                    On Error Resume Next
                    Add_Text(("TX: " & sStr))
                    For i = 1 To Len(sStr) Step 3
                        HexToChar((Mid(sStr, i, 2)))
                        While commPort.CtsHolding = False And Quit = False
                            System.Windows.Forms.Application.DoEvents()
                        End While
                        If Quit = True Then Exit Sub
                        commPort.Write(Chr(HexNum))
                    Next i
                    Exit Sub
errread:
                    On Error Resume Next
                    FileClose(1)
                    Exit Sub
notthere:
                    On Error Resume Next
                    FileClose(1)
                    Exit Sub
                Else
                    If TesterPresent = True Then
                        If commPort.IsOpen() = True Then
                            If Functional Then
                                x = &HC1S
                            Else
                                x = &H81S
                            End If
                            sStr = "TX: " & Hex(x) & " " & Hex(Target_Address) & " " & Hex(Source_Address) & " 3E"
                            sendstr = Chr(x) & Chr(Target_Address) & Chr(Source_Address) & Chr(&H3E)
                            x = x + Source_Address + Target_Address + &H3ES
                            While x > 255
                                x = x - 256
                            End While
                            sendstr = sendstr + Chr(x)
                            While commPort.CtsHolding = False And Quit = False
                                System.Windows.Forms.Application.DoEvents()
                            End While
                            If Quit = True Then Exit Sub
                            commPort.Write(sendstr)
                            Add_Text((sStr & " " & Hex(x)))
                        End If
                    End If
                End If
            End If
        End If
    End Sub
    Public Sub HexToChar(ByRef s As String)
        Dim i As Short
        i = Asc(VB.Left(s, 1))
        If i >= Asc("0") And i <= Asc("9") Then
            i = i - Asc("0")
        Else
            If i >= Asc("A") And i <= Asc("F") Then
                i = i - Asc("A")
                i = i + 10
            Else
                If i >= Asc("a") And i <= Asc("f") Then
                    i = i - Asc("a")
                    i = i + 10
                End If
            End If
        End If
        HexNum = i * 16
        i = Asc(VB.Right(s, 1))
        If i >= Asc("0") And i <= Asc("9") Then
            i = i - Asc("0")
        Else
            If i >= Asc("A") And i <= Asc("F") Then
                i = i - Asc("A")
                i = i + 10
            Else
                If i >= Asc("a") And i <= Asc("f") Then
                    i = i - Asc("a")
                    i = i + 10
                End If
            End If
        End If
        HexNum = HexNum + i
    End Sub



    Private Sub bStartLog_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bStartLog.Click
        If logging = False Then
            On Error GoTo cancelled
            CDSave.Title = "Select Log File to Save As"
            CDSave.ShowDialog()
            On Error GoTo badfile
            logfilesize = 0
            FileOpen(3, CDSave.FileName, OpenMode.Output)
            logging = True
            Exit Sub
badfile:
            On Error Resume Next
            MsgBox("Could not open " & CDSave.FileName & " for writing!", MsgBoxStyle.Critical, "Error")
            Exit Sub
cancelled:
            On Error Resume Next
            Exit Sub
        Else
            MsgBox("Logging has already been started using log file " & CDSave.FileName, MsgBoxStyle.Information, "Notice")
        End If
    End Sub
    Private Sub bStopLog_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bStopLog.Click
        If logging = False Then
            MsgBox("Logging has not been started yet!", MsgBoxStyle.Exclamation, "Error")
        Else
            On Error GoTo badclose
            FileClose(3)
            logging = False
            MsgBox("Log file size " & VB6.Format(logfilesize, "#0") & " saved to " & CDSave.FileName, MsgBoxStyle.Information, "Log File Saved")
            Exit Sub
badclose:
            On Error Resume Next
            MsgBox("Could not close " & CDSave.FileName, MsgBoxStyle.Critical, "Error")
            Exit Sub
        End If
    End Sub
End Class