/* RS232.H
 * RS232 module header file
 * 3/15/02 Prune
 */

#ifndef RS232_H_INCLUDED

#define RS232_H_INCLUDED

#ifdef RS232_MAIN

#define DECL

#else

#define DECL extern

#endif

#define TXCPLTE 0x40
#define TXRDY 0x20
#define RXRDY 0x01
#define BRK 0x10
#define DTR 0x01
#define RTS 0x02
#define DSR 0x20
#define CTS 0x10

DECL char InitComm(int port,unsigned long baudrate);
DECL int detect_UART(unsigned baseaddr);
DECL void handshake(const unsigned char settings);
DECL int MyWriteChar(int c);
DECL int MyReadCharPending(void);
DECL int MyReadChar(void);
DECL int MyReadCharTimed(long milliseconds);
DECL int MyClearRXBuffer(void);
DECL void clean_rs232(void);
DECL int modemstatus(void);
DECL int comport;

#endif
