VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "mscomm32.ocx"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form fTop 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "ISO-14230 Message Center 1.9.12"
   ClientHeight    =   6210
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6105
   Icon            =   "fTop.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6210
   ScaleWidth      =   6105
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin MSComDlg.CommonDialog CD 
      Left            =   1680
      Top             =   4560
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
   Begin VB.CommandButton bRun 
      Caption         =   "Go Directly to RUN (Listen to K-line)"
      Height          =   735
      Left            =   2160
      TabIndex        =   13
      Top             =   2640
      Width           =   1575
   End
   Begin VB.CommandButton bStopLog 
      Caption         =   "Stop Log"
      Height          =   735
      Left            =   4080
      TabIndex        =   12
      Top             =   2640
      Width           =   1695
   End
   Begin VB.CommandButton bStartLog 
      Cancel          =   -1  'True
      Caption         =   "Start Log"
      Height          =   735
      Left            =   240
      TabIndex        =   11
      Top             =   2640
      Width           =   1575
   End
   Begin VB.CommandButton bBtn9 
      Caption         =   "Request Last Keyword"
      Height          =   735
      Left            =   4080
      TabIndex        =   10
      Top             =   1800
      Width           =   1695
   End
   Begin VB.CommandButton bBtn8 
      Caption         =   "Clear ISO-14230 Box Buffers"
      Height          =   735
      Left            =   2160
      TabIndex        =   9
      Top             =   1800
      Width           =   1575
   End
   Begin VB.CommandButton bBtn7 
      Caption         =   "Request Status"
      Height          =   735
      Left            =   240
      TabIndex        =   8
      Top             =   1800
      Width           =   1575
   End
   Begin VB.Timer Timer2 
      Interval        =   100
      Left            =   120
      Top             =   4560
   End
   Begin VB.Timer Timer1 
      Interval        =   2000
      Left            =   1200
      Top             =   4560
   End
   Begin MSCommLib.MSComm comPort 
      Left            =   600
      Top             =   4440
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      Handshaking     =   2
      InBufferSize    =   16384
      RTSEnable       =   -1  'True
      BaudRate        =   19200
   End
   Begin VB.CommandButton bBtn6 
      Caption         =   "Send Initialization Sequence"
      Height          =   735
      Left            =   4080
      TabIndex        =   7
      Top             =   960
      Width           =   1695
   End
   Begin VB.CommandButton bBtn5 
      Caption         =   "Select Repeating Message"
      Height          =   735
      Left            =   2160
      TabIndex        =   6
      Top             =   960
      Width           =   1575
   End
   Begin VB.CommandButton bBtn4 
      Caption         =   "Clear Terminal Window"
      Height          =   735
      Left            =   240
      TabIndex        =   5
      Top             =   960
      Width           =   1575
   End
   Begin VB.CommandButton bBtn3 
      Caption         =   "Send Selected Message"
      Height          =   735
      Left            =   4080
      TabIndex        =   4
      Top             =   120
      Width           =   1695
   End
   Begin VB.CommandButton bBtn2 
      Caption         =   "Select/Edit Messages"
      Height          =   735
      Left            =   2160
      TabIndex        =   3
      Top             =   120
      Width           =   1575
   End
   Begin VB.CommandButton bBtn1 
      Caption         =   "Configure System"
      Height          =   735
      Left            =   240
      TabIndex        =   2
      Top             =   120
      Width           =   1575
   End
   Begin VB.TextBox tTerminalWindow 
      Height          =   2055
      Left            =   120
      Locked          =   -1  'True
      MaxLength       =   16384
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   3960
      Width           =   5775
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Terminal Window"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1800
      TabIndex        =   1
      Top             =   3480
      Width           =   2415
   End
End
Attribute VB_Name = "fTop"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub bRun_Click()
Dim sStr
If comPort.PortOpen = False Then
    MsgBox "Need to open COM port first."
    Exit Sub
End If
bRun.Enabled = False
Add_Text ("Go Directly to RUN mode")
Send_Message ("G")
j = 15
x = 0
recheck:
Wait_for_Response (j)
If RespRecvd = False Then
    x = x + 1
    If x < 7 Then GoTo recheck
    Add_Text ("ISO-14230 Box is Not Responding!")
    comPort.DTREnable = False
    bRun.Enabled = True
    Exit Sub
End If
gotone2:
GetErrorCode
If ErrorCode = Asc("O") Then
    comPort.DTREnable = True
    comPort.Handshaking = comRTS
    If TestMode = True Then
        bBtn5.Enabled = True
    End If
    DSRwait = True
    While comPort.DSRHolding = False And Quit = False
        DoEvents
    Wend
    DoEvents
    sStr = "."
    While Len(sStr) >= 1 And Quit = False
        sStr = comPort.Input
        DoEvents
    Wend
    TestRecvStarted = False
    RunMode = True
Else
    DisplayErrorCode
    comPort.DTREnable = False
End If
bRun.Enabled = True
TestRecvStarted = False
DSRwait = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
Dim vbres As VbMsgBoxResult
If logging = True Then
    vbres = MsgBox("Log file still logging!  Are you sure you want to quit now and close the log file?", vbYesNoCancel, "WARNING - LOG FILE STILL IN PROGRESS")
    If vbres = vbYes Then
        Close #3
        Cancel = False
        Quit = True
    Else
        Cancel = True
    End If
Else
    Quit = True
    Cancel = False
End If
End Sub
Private Sub bBtn1_Click()
fConfigure.Show
End Sub

Private Sub bBtn2_Click()
fMsgWindow.Show
End Sub

Private Sub bBtn3_Click()
Dim sStr2 As String
Dim i As Integer
Dim j As Integer
If comPort.PortOpen = False Then
    MsgBox "Need to open COM port first."
    Exit Sub
End If
If Selected_Message < 1 Then
    MsgBox "No message selected."
    Exit Sub
End If
bBtn3.Enabled = False
On Error GoTo errread
Open App.Path + "\KWP2000.MSG" For Input As #1
On Error GoTo notthere
For i = 1 To Selected_Message
    Input #1, sStr
Next i
Close #1
On Error Resume Next
If RunMode = False Then
    If Len(sStr) > (3 * 7) + 2 Then
        MsgBox "You can only send messages of 8 bytes or fewer when you are not in RUN mode. Note that you should not normally send messages when not in RUN mode."
        bBtn3.Enabled = True
        Exit Sub
    End If
End If
Add_Text ("TX: " + sStr)
If RunMode = False Then
    Add_Text ("Warning: Not in RUN mode; initialize module first!")
End If
j = 0: sStr2 = ""
For i = 1 To Len(sStr) Step 3
    HexToChar (Mid$(sStr, i, 2))
    If RunMode = False Then
        sStr2 = sStr2 + Chr$(HexNum)
        j = j + 1
    Else
        While comPort.CTSHolding = False And Quit = False
            DoEvents
        Wend
        If Quit = True Then Exit Sub
        comPort.Output = Chr$(HexNum)
    End If
Next i
If RunMode = False Then
    Retries = 0
resendm:
    Send_Message ("M" + Chr$(j) + sStr2)
    Wait_for_Response (15 + (((j * (InterByteDelay + 1)) / 50) + 1))
    If RespRecvd Then
        GetErrorCode
        If ErrorCode = Asc("O") Then
            Add_Text ("Transmitted OK.")
        Else
            DisplayErrorCode
        End If
    Else
        If Retries < 5 Then
            Retries = Retries + 1
            GoTo resendm
        End If
        Add_Text ("ISO-14230 box not responding!")
    End If
End If
resumepast:
Waiting = False
bBtn3.Enabled = True
Exit Sub
errread:
On Error Resume Next
MsgBox "Error reading " + App.Path + "\KWP2000.MSG!"
Close #1
bBtn3.Enabled = True
Exit Sub
notthere:
On Error Resume Next
MsgBox "Undefined selected message!"
Close #1
bBtn3.Enabled = True
Exit Sub
End Sub

Private Sub bBtn4_Click()
tTerminalWindow.Text = ""
End Sub

Private Sub bBtn5_Click()
'The following only works on
'certain computers and not
'others.  It was taken out
'to make this more compatible
'with all computers.
'
'If TestMode = True Then
'    If comPort.RTSEnable = True Then
'        comPort.RTSEnable = False
'    Else
'        comPort.RTSEnable = True
'    End If
'Else
    fTesterPresentMsg.Show
'End If
End Sub
Private Sub bBtn6_Click()
Dim i As Integer
Dim j As Integer
Dim x As Integer
Dim mode As String
If comPort.PortOpen = False Then
    MsgBox "Need to open COM port first."
    Exit Sub
End If
bBtn6.Enabled = False
comPort.DTREnable = False
DSRwait = True
While comPort.DSRHolding = True And Quit = False
    DoEvents
Wend
RunMode = False '1.7
If (PulseFast = True) Then
    Add_Text ("TX Pulse Init")
    Send_Message ("f" + Chr$(Int(PulseFastAmount / 256)) + Chr$(PulseFastAmount And 255))
    j = 15 + (PulseFastAmount / 100)
Else
    If Functional Then
        If AlternateMethod = True Then
            mode = "f"
        Else
            mode = "F"
        End If
    Else
        If AlternateMethod = True Then
            mode = "p"
        Else
            mode = "P"
        End If
    End If
    If FastInit Then
        Add_Text ("TX Fast Init")
        Send_Message ("F" + mode + Chr$(Source_Address) + Chr$(Target_Address))
        j = 15 + ((InterByteDelay) / 10)
    Else
        Add_Text ("TX Slow Init")
        'If CarbInit = True Then
        '    Send_Message ("C" + mode + Chr$(Source_Address) + Chr$(Target_Address))
        'Else
        Send_Message ("5" + mode + Chr$(Source_Address) + Chr$(Target_Address))
        'End If
        If (AlternateMethod = True) Then
            j = 2
        Else
            j = 25
        End If
    End If
End If
x = 0
recheck:
Wait_for_Response (j)
If RespRecvd = False Then
    x = x + 1
    If PulseFast = True Then
        If x < 1 Then GoTo recheck
    Else
        If AlternateMethod = True Then
            If x < 128 Then GoTo recheck
        Else
            If x < 7 Then GoTo recheck
        End If
    End If
    Add_Text ("ISO-14230 Box is Not Responding!")
    bBtn6.Enabled = True
    Exit Sub
End If
gotone2:
GetErrorCode
If ErrorCode = Asc("O") Then
    comPort.DTREnable = True
    comPort.Handshaking = comRTS
    RunMode = True
    If (((AlternateMethod = False) Or (FastInit = True)) And (PulseFast = False)) Then
        Get_Keyword (True)
    Else
        Add_Text ("Initialized.")
        Timer1_Timer
    End If
Else
    DisplayErrorCode
End If
bBtn6.Enabled = True
TestRecvStarted = False
DSRwait = False
End Sub

Private Sub bBtn7_Click()
If comPort.PortOpen = False Then
    MsgBox "Need to open COM port first."
    Exit Sub
End If
comPort.DTREnable = False
DSRwait = True
If comPort.DSRHolding = True Then
    Add_Text ("Exiting RUN mode to query status...")
    While comPort.DSRHolding = True And Quit = False
        DoEvents
    Wend
End If
If comPort.DSRHolding = False Then
    RunMode = False
    comPort.Handshaking = comNone
    If Quit = False Then
        SendQuery = True
    End If
End If
DSRwait = False
End Sub

Private Sub bBtn8_Click()
If comPort.PortOpen = False Then
    MsgBox "Need to open COM port first."
    Exit Sub
End If
comPort.DTREnable = False
DSRwait = True
While comPort.DSRHolding = True And Quit = False
    DoEvents
Wend
comPort.Handshaking = comNone
RunMode = False
Retries = 0
resendx:
Send_Message ("X")
Wait_for_Response (5)
If RespRecvd Then
    GetErrorCode
    If ErrorCode = Asc("O") Then
        Add_Text ("ISO-14230 Buffers cleared.")
    Else
        DisplayErrorCode
    End If
Else
    Retries = Retries + 1
    If Retries < 5 Then GoTo resendx
    Add_Text ("ISO-14230 Box is not responding!")
End If
DSRwait = False
End Sub

Private Sub bBtn9_Click()
If comPort.PortOpen = False Then
    MsgBox "Need to open COM port first."
    Exit Sub
End If
comPort.DTREnable = False
DSRwait = True
While comPort.DSRHolding = True And Quit = False
    DoEvents
Wend
RunMode = False
comPort.Handshaking = comNone
Get_Keyword (False)
DSRwait = False
End Sub
Public Sub Get_Keyword(initflag As Boolean)
If comPort.PortOpen = False Then
    MsgBox "Need to open COM port first."
    Exit Sub
End If
Retries = 0
resendk:
Send_Message ("K")
Wait_for_Response (5)
If Len(sStr) > 8 Then GoTo gotone3
badresp3:
Retries = Retries + 1
If Retries < 5 Then GoTo resendk
If initflag = True Then
    Add_Text ("Initialized but ISO-14230 Box won't respond after that!")
    comPort.DTREnable = True
    comPort.Handshaking = comRTS
    RunMode = True
    If TestMode = True Then
        TestRecvStarted = False
        bBtn5.Enabled = True
    End If
Else
    Add_Text ("ISO-14230 box is not responding to keyword request.")
End If
Exit Sub
gotone3:
For i = Len(sStr) - 7 To 1 Step -1
    If Mid$(sStr, i, 5) = "RESP:" Then
        GoTo gotresp3
    End If
Next i
GoTo badresp3
gotresp3:
sStr = Mid$(sStr, i, 9)
i = 1
If initflag = True Then
    comPort.DTREnable = True
    comPort.Handshaking = comRTS
    RunMode = True
    If TestMode = True Then
        TestRecvStarted = False
        bBtn5.Enabled = True
    End If
End If
x = 0
For j = i To Len(sStr) - 2
    x = x + Asc(Mid$(sStr, j, 1))
    If x >= 256 Then x = x - 256
Next j
If x = Asc(Mid$(sStr, Len(sStr) - 1, 1)) Then
    If 255 - x = Asc(Right$(sStr, 1)) Then
        KeyWord = ((Asc(Mid$(sStr, i + 5, 1))))
        KeyWord = KeyWord * 256
        KeyWord = KeyWord + (Asc(Mid$(sStr, i + 6, 1)))
        If initflag = True Then
            Add_Text ("Initialized with Keyword " + Hex$(KeyWord) + "H")
        Else
            Add_Text ("Most recent initialization had Keyword of " + Hex$(KeyWord) + "H")
        End If
    Else
        Add_Text ("Received bad 2nd byte of checksum of keyword request.")
    End If
Else
    Add_Text ("Received bad 1st byte of checksum of keyword request")
End If
If (FastInit = False And AlternateMethod = True) Then
    Retries = 0
resendz:
    Send_Message ("Z")
    Wait_for_Response (5)
    If Len(sStr) > 8 Then GoTo gotone9
badresp9:
    Retries = Retries + 1
    If Retries < 5 Then GoTo resendz
    Add_Text ("ISO-14230 box is not responding to system ID request; make sure firmware is at least revision 18.")
End If
Exit Sub
gotone9:
For i = Len(sStr) - 7 To 1 Step -1
    If Mid$(sStr, i, 5) = "RESP:" Then
        GoTo gotresp9
    End If
Next i
GoTo badresp9
gotresp9:
sStr = Mid$(sStr, i, 9)
i = 1
x = 0
For j = i To Len(sStr) - 2
    x = x + Asc(Mid$(sStr, j, 1))
    If x >= 256 Then x = x - 256
Next j
If x = Asc(Mid$(sStr, Len(sStr) - 1, 1)) Then
    If 255 - x = Asc(Right$(sStr, 1)) Then
        SystemID = ((Asc(Mid$(sStr, i + 5, 1))))
        SystemID = SystemID * 256
        SystemID = SystemID + (Asc(Mid$(sStr, i + 6, 1)))
        Add_Text ("Most recent initialization had System ID of " + Hex$(SystemID) + "H")
    Else
        Add_Text ("Received bad 2nd byte of checksum of system ID request.")
    End If
Else
    Add_Text ("Received bad 1st byte of checksum of system ID request")
End If
End Sub


Private Sub Form_Load()
Dim i As Integer
If Quit = True Then
    Exit Sub
End If
fTop.Hide
If App.PrevInstance Then
MsgBox "Already Running"
End
End If
inAddText = False
TestRecvStarted = False
RunMode = False
SendQuery = False
in_Timer2 = False
VoltageSelectionChanged = False
AlternateMethod = False
TimeVal = 2
frmSplash.Show
Loaded = False
TestMode = False
BaudRate = 10400
InterByteDelay = 5
SendHeader = "14230"
tTerminalWindow.Text = ""
On Error GoTo nodata
Open App.Path + "\KWP2000.CFG" For Input As #1
On Error GoTo baddata
Input #1, sStr
If Val(sStr) >= 1 And Val(sStr) <= 16 Then
    comPort.CommPort = Val(sStr)
Else
    comPort.CommPort = 1
End If
Input #1, sStr
If Val(sStr) >= 1 Then
    FastInit = True
Else
    FastInit = False
End If
Input #1, sStr
Selected_Message = Val(sStr)
Input #1, sStr
Source_Address = Val(sStr)
Input #1, sStr
Target_Address = Val(sStr)
Input #1, sStr
If Val(sStr) >= 1 Then
    TesterPresent = True
Else
    TesterPresent = False
End If
Input #1, sStr
If Val(sStr) >= 1 Then
    CustomTesterPresent = True
    bBtn5.Enabled = True
Else
    CustomTesterPresent = False
    bBtn5.Enabled = False
End If
Input #1, sStr
Tester_Present_Message = Val(sStr)
Input #1, sStr
VoltageSelection = Val(sStr)
Input #1, sStr
If Val(sStr) >= 1 Then
    Functional = True
Else
    Functional = False
End If
On Error GoTo notdefyet
Input #1, sStr
BaudRate = Val(sStr)
If BaudRate < 1000 Then
    BaudRate = 10400
End If
If ThreeXSpeed = True Then
    If BaudRate > 31250 Then
        BaudRate = 31250
    End If
Else
    If BaudRate > 10400 Then
        BaudRate = 10400
    End If
End If
Input #1, sStr
InterByteDelay = Val(sStr)
If InterByteDelay < 0 Or InterByteDelay > 51 Then
    InterByteDelay = 5
End If
Input #1, sStr
If Val(sStr) > 0 Then
    AlternateMethod = True
Else
    AlternateMethod = False
End If
Input #1, sStr
If (Val(sStr) > 0) Then
    PulseFast = True
Else
    PulseFast = False
End If
Input #1, sStr
PulseFastAmount = Val(sStr)
If (PulseFastAmount = 0 Or PulseFastAmount > 12500) Then
    PulseFastAmount = 70
End If
Close #1
backtomain:
On Error Resume Next
Loaded = True
BaudRateChanged = True
VoltageSelectionChanged = True
InterByteChanged = True
Retries = 0
GoTo donewiththis
If comPort.DSRHolding = False Then
    'make sure to set DTR false
    'or the ISO-14230 box will
    'not listen to us while it
    'is de-asserting DSR
    comPort.DTREnable = False
    comPort.RTSEnable = True
    If comPort.CTSHolding = True Then
sendit0:
        Retries = 0
sendit: DoEvents
        DoEvents
        DoEvents
        DoEvents
        DoEvents
        sStr = comPort.Input 'clear rx buf
        If comPort.DSRHolding = True Then
            GoTo alreadyrun
        End If
        Send_Message ("R")
        Wait_for_Response (5)
        If RespRecvd = False Then
            Retries = Retries + 1
            If Retries > 5 Then
                Add_Text ("ISO-14230 box is not responding to revision request!")
                GoTo sendit2
            Else
                GoTo sendit
            End If
        End If
        GetErrorCode
        Add_Text ("ISO-14230 Box Revision" + Str$(ErrorCode))
        If ErrorCode < 3 Then
            Add_Text ("This rev has a bug in receive fast init response!")
        End If
        DoEvents
sendit2:
        Retries = 0
sendit3:
        If comPort.DSRHolding = True Then
            GoTo alreadyrun
        End If
        Send_Message ("?")
        Wait_for_Response (5)
        If RespRecvd Then GoTo gotone
        Retries = Retries + 1
        If Retries > 5 Then
            Add_Text ("ISO-14230 Box is not Responding!")
            GoTo donewiththis
        Else
            GoTo sendit3
        End If
    Else
        Timestamp = HundredMsec
        DoEvents
        While ((HundredMsec - Timestamp < 5) And (HundredMsec - Timestamp >= 0))
            If comPort.CTSHolding = True Then
                GoTo sendit
            End If
            DoEvents
        Wend
        Add_Text ("ISO-14230 Box is not connected!")
        SendQuery = False
        GoTo donewiththis
    End If
gotone:
    GetErrorCode
    If ErrorCode = Asc("O") Then
        Add_Text ("ISO-14230 Box Ready.")
    Else
        DisplayErrorCode
    End If
Else
alreadyrun:
    Add_Text ("ISO-14230 Box is Already in RUN Mode!")
    RunMode = True
    comPort.DTREnable = True
    comPort.Handshaking = comRTS
End If
donewiththis:
backtomain2:
If AlternateMethod = True And FastInit = False Then
   Timer1.Interval = FAST_INTERVAL
Else
    Timer1.Interval = 2000
End If
On Error Resume Next
While TimeVal > 0
   DoEvents
Wend
Quit = False
fTop.Show
While Quit = False
    If RunMode = False And SendQuery = True And fTop.comPort.PortOpen = True Then
        SendQuery = False
        GoTo sendit0
    End If
    DoEvents
Wend
End
Exit Sub
nodata:
On Error Resume Next
comPort.CommPort = 1
FastInit = True
Selected_Message = 1
Source_Address = 0
Target_Address = 0
Loaded = True
GoTo backtomain
baddata:
On Error Resume Next
Close #1
MsgBox "Bad data found in file " + App.Path + "\KWP2000.CFG."
comPort.CommPort = 1
FastInit = True
Selected_Message = 1
Source_Address = 0
Target_Address = 0
PulseFastAmount = 70
PulseFast = False
Loaded = True
GoTo backtomain
notdefyet:
On Error Resume Next
Close #1
Loaded = True
GoTo backtomain
badcomm:
MsgBox "Could not initialize COM port!"
GoTo backtomain2
End Sub


Private Sub Form_Resize()
If Me.Width > 350 Then
    tTerminalWindow.Width = Me.Width - 330
End If
If Me.Height > 4800 Then
    tTerminalWindow.Height = Me.Height - 4550
End If
End Sub

Private Sub Form_Terminate()
Quit = True
End Sub


Private Sub Timer2_Timer()
Dim recvStr As String
Dim buildStr As String
Dim hexstr As String
Dim i As Integer
If HundredMsec < 32767 Then
    HundredMsec = HundredMsec + 1
Else
    HundredMsec = 0
End If
If inAddText = True Or Quit = True Or in_Timer2 = True Then
    Exit Sub
End If
If comPort.PortOpen = False Then
    Exit Sub
End If
in_Timer2 = True
If comPort.DTREnable = True And comPort.DSRHolding = False And bRun.Enabled = True Then
backtoinit:
    Add_Text ("Going back to init mode...")
    RunMode = False
    comPort.Handshaking = comNone
    comPort.DTREnable = False
    comPort.RTSEnable = True
    If TestMode = True Then
        TestRecvStarted = False
        bBtn5.Enabled = False
    End If
    SendQuery = True
    sStr = comPort.Input 'clear rx buf
    While comPort.DSRHolding = True And Quit = False
        DoEvents
        sStr = comPort.Input
    Wend
    sStr = comPort.Input
End If
If Waiting = False And RunMode = True Then
    recvStr = comPort.Input
    If Len(recvStr) >= comPort.InBufferSize Then
        Add_Text ("PC RX Buffer Overflow")
        GoTo backtoinit
    End If
    If Len(recvStr) > 0 Then
        RecvDataStamp = HundredMsec
        If TestMode Then
            DoEvents
            While Len(recvStr) > 0
                'DoEvents
                If TestRecvStarted Then
                    If Asc(Left$(recvStr, 1)) = TestChar Then
                        If TestChar < 255 Then
                            TestChar = TestChar + 1
                        Else
                            Add_Text ("RX: 256 bytes in order (test mode)")
                            TestChar = 0
                        End If
                    Else
                        Add_Text ("RX: " + Hex$(Asc(Left$(recvStr, 1))) + " Expected " + Hex$(TestChar) + " (test mode error!)")
                        GoTo backtoinit
                    End If
                Else
                    TestRecvStarted = True
                    TestChar = Asc(Left$(recvStr, 1))
                    If TestChar < 255 Then
                        TestChar = TestChar + 1
                    Else
                        TestChar = 0
                    End If
                End If
                If Len(recvStr) > 1 Then
                    recvStr = Right$(recvStr, Len(recvStr) - 1)
                Else
                    recvStr = ""
                End If
            Wend
        Else
            buildStr = "RX:"
            For i = 1 To Len(recvStr)
                hexstr = Hex$(Asc(Mid$(recvStr, i, 1)))
                While Len(hexstr) < 2
                    hexstr = "0" + hexstr
                Wend
                buildStr = buildStr + " " + hexstr
            Next i
            Add_Text (buildStr)
        End If
    End If
End If
in_Timer2 = False
End Sub

Private Sub Timer1_Timer()
Dim i As Integer
Dim x As Integer
Dim sStr As String
Dim Retries As Integer
If Quit = True Then Exit Sub
If comPort.CTSHolding = False Then Exit Sub
If comPort.PortOpen = False Then
    Exit Sub
End If
If BaudRateChanged = True And RunMode = False And Quit = False Then
    BaudRateChanged = False
    sStr = Chr$(Int(BaudRate / 256))
    sStr = sStr + Chr$(BaudRate And 255)
    Retries = 0
Resend00:
    If Quit = True Then Exit Sub
    If comPort.CTSHolding = False Then Exit Sub
    If DSRHolding = True Then 'user went quickly into
        GoTo resumepast200    'run mode, so skip this
    End If                    'init mode command
    Send_Message ("B" + sStr)
    Wait_for_Response (5)
    If RespRecvd = False Then
        Retries = Retries + 1
        If Retries > 5 Then
            Add_Text ("ISO-14230 Box is Not Responding to Baud Rate Selection!")
            GoTo resumepast200
        Else
            GoTo Resend00
        End If
    End If
    GetErrorCode
    If ErrorCode = Asc("O") Then
        Add_Text ("Baud Rate" + Str$(BaudRate) + " Sent OK.")
    Else
        DisplayErrorCode
    End If
End If
resumepast200:
If comPort.CTSHolding = False Then Exit Sub
If Quit = True Then Exit Sub
If InterByteChanged = True And RunMode = False And Quit = False Then
    InterByteChanged = False
    sStr = Chr$(InterByteDelay)
    Retries = 0
Resend2001:
    If Quit = True Then Exit Sub
    If comPort.CTSHolding = False Then Exit Sub
    If DSRHolding = True Then 'user went quickly into
        GoTo resumepast2001   'run mode, so skip this
    End If                    'init mode command
    Send_Message ("I" + sStr)
    Wait_for_Response (5)
    If RespRecvd = False Then
        Retries = Retries + 1
        If Retries > 5 Then
            Add_Text ("ISO-14230 Box is Not Responding to InterByte Delay Selection!")
            GoTo resumepast2001
        Else
            GoTo Resend2001
        End If
    End If
    GetErrorCode
    If ErrorCode = Asc("O") Then
        Add_Text ("InterByte Delay" + Str$(InterByteDelay) + " ms Sent OK.")
    Else
        DisplayErrorCode
    End If
End If
resumepast2001:
If Quit = True Then Exit Sub
If comPort.CTSHolding = False Then Exit Sub
If VoltageSelectionChanged And RunMode = False And Quit = False Then
    VoltageSelectionChanged = False
    If VoltageSelection = 1 Then
        sStr = Chr$(0)
    Else
        If VoltageSelection = 2 Then
            sStr = Chr$(12)
        Else
            If VoltageSelection = 3 Then
                sStr = Chr$(24)
            Else
                sStr = Chr$(0)
            End If
        End If
    End If
    Retries = 0
Resend:
    If comPort.CTSHolding = False Then Exit Sub
    If Quit = True Then Exit Sub
    If DSRHolding = True Then 'user went quickly into
        GoTo resumepast2      'run mode, so skip this
    End If                    'init mode command
    Send_Message ("V" + sStr)
    Wait_for_Response (5)
    If RespRecvd = False Then
        Retries = Retries + 1
        If Retries > 5 Then
            Add_Text ("ISO-14230 Box is Not Responding to Voltage Selection!")
            GoTo resumepast2
        Else
            GoTo Resend
        End If
    End If
    GetErrorCode
    If ErrorCode = Asc("O") Then
        Add_Text ("Voltage Selection Sent OK.")
    Else
        DisplayErrorCode
    End If
End If
resumepast2:
If Quit = True Then Exit Sub
If comPort.CTSHolding = False Then Exit Sub
If TesterPresent = True And Loaded And RunMode And Quit = False Then
    If InMiddleOfMessage = False And _
        ((((HundredMsec - RecvDataStamp) >= 1) And _
          (AlternateMethod = True) And _
          (FastInit = False) And (PulseFast = False)) Or _
          ((HundredMsec - RecvDataStamp) >= 10) Or _
        ((HundredMsec - RecvDataStamp) < 0)) Then
        RecvDataStamp = HundredMsec
        If CustomTesterPresent = True And TesterPresent = True Then
            If Tester_Present_Message < 1 Then
               Exit Sub
            End If
            If comPort.PortOpen = False Then
                Exit Sub
            End If
            On Error GoTo errread
            Open App.Path + "\KWP2000.MSG" For Input As #1
            On Error GoTo notthere
            For i = 1 To Tester_Present_Message
            Input #1, sStr
            Next i
            Close #1
            On Error Resume Next
            Add_Text ("TX: " + sStr)
            For i = 1 To Len(sStr) Step 3
                HexToChar (Mid$(sStr, i, 2))
                While comPort.CTSHolding = False And Quit = False
                    DoEvents
                Wend
                If Quit = True Then Exit Sub
                comPort.Output = Chr$(HexNum)
            Next i
            Exit Sub
errread:
            On Error Resume Next
            Close #1
            Exit Sub
notthere:
            On Error Resume Next
            Close #1
            Exit Sub
        Else
            If TesterPresent = True Then
                If comPort.PortOpen = True Then
                    If Functional Then
                        x = &HC1
                    Else
                        x = &H81
                    End If
                    sStr = "TX: " + Hex$(x) + " " + Hex$(Target_Address) + " " + Hex$(Source_Address) + " 3E"
                    While comPort.CTSHolding = False And Quit = False
                        DoEvents
                    Wend
                    If Quit = True Then Exit Sub
                    comPort.Output = Chr$(x) + Chr$(Target_Address) + Chr$(Source_Address) + Chr$(&H3E)
                    x = x + Source_Address + Target_Address + &H3E
                    While x > 255
                        DoEvents
                        x = x - 256
                    Wend
                    While comPort.CTSHolding = False And Quit = False
                        DoEvents
                    Wend
                    If Quit = True Then Exit Sub
                    comPort.Output = Chr$(x)
                    Add_Text (sStr + " " + Hex$(x))
                End If
            End If
        End If
    End If
End If
End Sub
Public Sub HexToChar(s As String)
Dim i As Integer
i = Asc(Left$(s, 1))
If i >= Asc("0") And i <= Asc("9") Then
    i = i - Asc("0")
Else
    If i >= Asc("A") And i <= Asc("F") Then
        i = i - Asc("A")
        i = i + 10
    Else
        If i >= Asc("a") And i <= Asc("f") Then
            i = i - Asc("a")
            i = i + 10
        End If
    End If
End If
HexNum = i * 16
i = Asc(Right$(s, 1))
If i >= Asc("0") And i <= Asc("9") Then
    i = i - Asc("0")
Else
    If i >= Asc("A") And i <= Asc("F") Then
        i = i - Asc("A")
        i = i + 10
    Else
        If i >= Asc("a") And i <= Asc("f") Then
            i = i - Asc("a")
            i = i + 10
        End If
    End If
End If
HexNum = HexNum + i
End Sub



Private Sub bStartLog_Click()
If logging = False Then
    CD.CancelError = True
    On Error GoTo cancelled
    CD.DialogTitle = "Select Log File to Save As"
    CD.ShowSave
    On Error GoTo badfile
    logfilesize = 0
    Open CD.FileName For Output As #3
    logging = True
    Exit Sub
badfile:
    On Error Resume Next
    MsgBox "Could not open " + CD.FileName + " for writing!", vbCritical, "Error"
    Exit Sub
cancelled:
    On Error Resume Next
    Exit Sub
Else
    MsgBox "Logging has already been started using log file " + CD.FileName, vbInformation, "Notice"
End If
End Sub
Private Sub bStopLog_Click()
If logging = False Then
    MsgBox "Logging has not been started yet!", vbExclamation, "Error"
Else
    On Error GoTo badclose
    Close #3
    logging = False
    MsgBox "Log file size " + Format(logfilesize, "#0") + " saved to " + CD.FileName, vbInformation, "Log File Saved"
    Exit Sub
badclose:
    On Error Resume Next
    MsgBox "Could not close " + CD.FileName, vbCritical, "Error"
    Exit Sub
End If
End Sub

