Option Strict Off
Option Explicit On
Friend Class fConfigure
	Inherits System.Windows.Forms.Form
	Dim sStr As String
	Dim JustGotIn As Boolean
    Dim IgnoreVoltageSelChange As Boolean

    Private Sub bEnable_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles bEnable.Click
        Dim sStr As String = ""
        On Error GoTo badport
        If fTopForm.commPort.IsOpen() = True Then
            fTopForm.commPort.Close()
        End If
        fTopForm.commPort.BaudRate = 19200
        fTopForm.commPort.RtsEnable = True
        fTopForm.commPort.Encoding = System.Text.Encoding.Default()
        fTopForm.commPort.Handshake = IO.Ports.Handshake.RequestToSend
        fTopForm.commPort.Open()
        lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
        fTopForm.commPort.DiscardInBuffer() 'clear rx buf
        'If DSR Is False Then we are
        ' init mode, so query errors
        If fTopForm.commPort.DsrHolding = False Then
            'make sure to set DTR false
            'or the ISO-14230 box will
            'not listen to us while it
            'is de-asserting DSR
            fTopForm.commPort.DtrEnable = False
            If fTopForm.commPort.CtsHolding = True Then
                Retries = 0
sendit:         System.Windows.Forms.Application.DoEvents()
                System.Windows.Forms.Application.DoEvents()
                System.Windows.Forms.Application.DoEvents()
                System.Windows.Forms.Application.DoEvents()
                System.Windows.Forms.Application.DoEvents()
                fTopForm.commPort.DiscardInBuffer() 'clear rx buf
                If fTopForm.commPort.DsrHolding = True Then
                    GoTo alreadyrun
                End If
                XmitMask = XmitMask Or XMIT_REVISION
                XmitMask = XmitMask Or XMIT_STATUS
            Else
                Timestamp = HundredMsec
                System.Windows.Forms.Application.DoEvents()
                While ((HundredMsec - Timestamp < 5) And (HundredMsec - Timestamp) >= 0)
                    If fTopForm.commPort.CtsHolding = True Then
                        GoTo sendit
                    End If
                    System.Windows.Forms.Application.DoEvents()
                End While
                Add_Text(("ISO-14230 Box is not connected!"))
                SendQuery = False
                GoTo donewiththis
            End If
        Else
alreadyrun:
            Add_Text(("ISO-14230 Box is Already in RUN Mode!"))
            RunMode = True
            fTopForm.commPort.DtrEnable = True
        End If
donewiththis:
        On Error Resume Next
        If fTopForm.commPort.IsOpen() = True Then
            lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
        Else
            lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        End If
        Exit Sub
badport:
        On Error Resume Next
        MsgBox("Could not open COM port " + fTopForm.commPort.PortName)
        lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
    End Sub

    Private Sub cAlt_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cAlt.CheckStateChanged
        AlternateMethod = cAlt.CheckState
        If AlternateMethod = True And FastInit = False Then
            fTop.Timer1.Interval = FAST_INTERVAL
        Else
            fTop.Timer1.Interval = 2000
        End If
        If Loaded Then SaveData()
    End Sub

    Private Sub Check2_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Check2.CheckStateChanged
        TesterPresent = Check2.CheckState
        If Loaded Then SaveData()
    End Sub

    Private Sub Check3_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Check3.CheckStateChanged
        If Check3.CheckState = 1 Then
            CustomTesterPresent = True
            fTopForm.bBtn5.Enabled = True
        Else
            CustomTesterPresent = False
            fTopForm.bBtn5.Enabled = False
        End If
        If Loaded Then SaveData()
    End Sub

    Private Sub Check4_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Check4.CheckStateChanged
        Functional = Check4.CheckState
        If Loaded Then SaveData()
    End Sub

    Private Sub Check5_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Check5.CheckStateChanged
        TestMode = Check5.CheckState
        TestRecvStarted = False
    End Sub

    Private Sub Combo1_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Combo1.SelectedIndexChanged
        Voltage_Selection = Combo1.SelectedIndex + 1
        If Loaded Then SaveData()
        If IgnoreVoltageSelChange = False Then
            VoltageSelectionChanged = True
        End If
    End Sub

    Private Sub fConfigure_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim i As Short
        Dim j As Short
        Dim sel As Boolean = False
        JustGotIn = True
        Combo1.Items.Add("Detect")
        Combo1.Items.Add("12V")
        Combo1.Items.Add("24V")
        If Voltage_Selection >= 1 And Voltage_Selection <= 3 Then
            If Voltage_Selection = 1 Then
                IgnoreVoltageSelChange = True
            End If
            Combo1.SelectedIndex = Voltage_Selection - 1
        Else
            IgnoreVoltageSelChange = True
            Combo1.SelectedIndex = 0
        End If
        Combo1.Text = VB6.GetItemString(Combo1, Combo1.SelectedIndex)
        IgnoreVoltageSelChange = False
        If FastInit Then
            Check1.CheckState = System.Windows.Forms.CheckState.Checked
        Else
            Check1.CheckState = System.Windows.Forms.CheckState.Unchecked
        End If
        If TestMode Then
            Check5.CheckState = System.Windows.Forms.CheckState.Checked
        Else
            Check5.CheckState = System.Windows.Forms.CheckState.Unchecked
        End If
        If Functional Then
            Check4.CheckState = System.Windows.Forms.CheckState.Checked
        Else
            Check4.CheckState = System.Windows.Forms.CheckState.Unchecked
        End If
        If CustomTesterPresent Then
            Check3.CheckState = System.Windows.Forms.CheckState.Checked
        Else
            Check3.CheckState = System.Windows.Forms.CheckState.Unchecked
        End If
        If TesterPresent Then
            Check2.CheckState = System.Windows.Forms.CheckState.Checked
        Else
            Check2.CheckState = System.Windows.Forms.CheckState.Unchecked
        End If
        If AlternateMethod Then
            cAlt.CheckState = System.Windows.Forms.CheckState.Checked
        Else
            cAlt.CheckState = System.Windows.Forms.CheckState.Unchecked
        End If
        tSourceAddr.Text = Hex(Source_Address)
        tTargetAddr.Text = Hex(Target_Address)
        tBaud.Text = VB6.Format(BaudRate, "#0")
        tInter.Text = VB6.Format(InterByteDelay, "#0")
        tPulseAmount.Text = VB6.Format(PulseFastAmount, "#0")
        If (PulseFast = True) Then
            cPulse.CheckState = CheckState.Checked
        Else
            cPulse.CheckState = CheckState.Unchecked
        End If
        lbCOM.Items.Clear()
        j = 0
        For i = 0 To 255
            If goodport(i) = True Then
                j = j + 1
                lbCOM.Items.Add("COM" + VB6.Format(i, "#0"))
                If i = Val(Mid(fTopForm.commPort.PortName, 4)) Then
                    lbCOM.SelectedIndex = j - 1
                    sel = True
                End If
            End If
        Next
        If (j > 0 And sel = False) Then
            lbCOM.SelectedIndex = 0
            If fTopForm.commPort.IsOpen() = True Then
                fTopForm.commPort.Close()
            End If
            On Error GoTo notgood
            fTopForm.commPort.PortName = lbCOM.Items(lbCOM.SelectedIndex)
            On Error Resume Next
            lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        End If
        Exit Sub
notgood:
        On Error Resume Next
        lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        If fTopForm.commPort.IsOpen() = True Then
            lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
        Else
            lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        End If
        JustGotIn = False
    End Sub

    Private Sub Check1_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Check1.CheckStateChanged
        FastInit = Check1.CheckState
        If AlternateMethod = True And FastInit = False Then
            fTop.Timer1.Interval = FAST_INTERVAL
        Else
            fTop.Timer1.Interval = 2000
        End If
        If Loaded Then SaveData()
    End Sub

    Private Sub tBaud_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tBaud.TextChanged
        Dim entered As Long
        entered = Val(tBaud.Text)
        If entered < 1000 Or entered > 10417 Then
            tBaud.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        Else
            tBaud.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
            BaudRate = entered
            BaudRateChanged = True
            If Loaded Then SaveData()
        End If
        'End If
    End Sub

    Private Sub tInter_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tInter.TextChanged
        Dim entered As Short
        entered = Val(tInter.Text)
        If entered < 0 Or entered > 51 Then
            tInter.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        Else
            tInter.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
            InterByteDelay = entered
            InterByteChanged = True
            If Loaded Then SaveData()
        End If
    End Sub

    Private Sub tSourceAddr_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tSourceAddr.TextChanged
        Dim i As Short
        Dim c As Short
        If Len(tSourceAddr.Text) > 2 Or Len(tSourceAddr.Text) < 1 Then
invalid:
            tSourceAddr.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
            Exit Sub
        End If
        For i = 1 To Len(tSourceAddr.Text)
            c = Asc(Mid(tSourceAddr.Text, i, 1))
            If c >= Asc("0") And c <= Asc("9") Then
                If i = 1 Then
                    Source_Address = c - Asc("0")
                Else
                    Source_Address = Source_Address * 16
                    Source_Address = Source_Address + (c - Asc("0"))
                End If
            Else
                If c >= Asc("a") And c <= Asc("f") Then
                    If i = 1 Then
                        Source_Address = (c - Asc("a")) + 10
                    Else
                        Source_Address = Source_Address * 16
                        Source_Address = Source_Address + (c - Asc("a")) + 10
                    End If
                Else
                    If c >= Asc("A") And c <= Asc("F") Then
                        If i = 1 Then
                            Source_Address = (c - Asc("A")) + 10
                        Else
                            Source_Address = Source_Address * 16
                            Source_Address = Source_Address + (c - Asc("A")) + 10
                        End If
                    Else
                        GoTo invalid
                    End If
                End If
            End If
        Next i
        tSourceAddr.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
        If Loaded Then SaveData()
    End Sub

    Private Sub tTargetAddr_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles tTargetAddr.TextChanged
        Dim i As Short
        Dim c As Short
        If Len(tTargetAddr.Text) > 2 Or Len(tTargetAddr.Text) < 1 Then
invalid:
            tTargetAddr.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
            Exit Sub
        End If
        For i = 1 To Len(tTargetAddr.Text)
            c = Asc(Mid(tTargetAddr.Text, i, 1))
            If c >= Asc("0") And c <= Asc("9") Then
                If i = 1 Then
                    Target_Address = c - Asc("0")
                Else
                    Target_Address = Target_Address * 16
                    Target_Address = Target_Address + (c - Asc("0"))
                End If
            Else
                If c >= Asc("a") And c <= Asc("f") Then
                    If i = 1 Then
                        Target_Address = (c - Asc("a")) + 10
                    Else
                        Target_Address = Target_Address * 16
                        Target_Address = Target_Address + (c - Asc("a")) + 10
                    End If
                Else
                    If c >= Asc("A") And c <= Asc("F") Then
                        If i = 1 Then
                            Target_Address = (c - Asc("A")) + 10
                        Else
                            Target_Address = Target_Address * 16
                            Target_Address = Target_Address + (c - Asc("A")) + 10
                        End If
                    Else
                        GoTo invalid
                    End If
                End If
            End If
        Next i
        tTargetAddr.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255, 255))
        If Loaded Then SaveData()
    End Sub


    Private Sub Check5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Check5.CheckedChanged
        If Check5.Checked = True Then
            If XmitTestSequence = True Then
                fTopForm.bBtn3.Text = "Stop Test Sequence"
            Else
                fTopForm.bBtn3.Text = "Send Test Sequence"
            End If
            TestMode = True
        Else
            fTopForm.bBtn3.Text = "Send Selected Message"
            TestMode = False
        End If
    End Sub

    Private Sub lbCOM_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbCOM.SelectedIndexChanged
        On Error GoTo notgood
        If JustGotIn = True Then
            Exit Sub
        End If
        If fTopForm.commPort.IsOpen() = True Then
            fTopForm.commPort.Close()
        End If
        On Error GoTo notgood
        fTopForm.commPort.PortName = lbCOM.Items(lbCOM.SelectedIndex)
        lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))
        If Loaded Then SaveData()
        Exit Sub
notgood:
        On Error Resume Next
        lbCOM.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 0, 0))

    End Sub

    Private Sub tPulseAmount_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tPulseAmount.TextChanged
        On Error GoTo notgoodent
        PulseFastAmount = Val(tPulseAmount.Text)
        tPulseAmount.BackColor = Color.White
        If Loaded Then SaveData()
        On Error Resume Next
        Exit Sub
notgoodent:
        On Error Resume Next
        tPulseAmount.BackColor = Color.Red
    End Sub

    Private Sub cPulse_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cPulse.CheckedChanged
        PulseFast = cPulse.CheckState
        If Loaded Then SaveData()
    End Sub
End Class