Attribute VB_Name = "Main"
Option Explicit

Global Const ThreeXSpeed = False
'if change this dont forget to
'change caption on top form
'and change baud rate of COM
'control on fTop
Global Const FAST_INTERVAL = 100

Global AlternateMethod As Boolean '14
Global CarbInit As Boolean
Global logging As Boolean
Global logfilesize As Long
Global InterByteDelay As Integer
Global InterByteChanged As Boolean
Global BaudRateChanged As Boolean
Global BaudRate As Integer
Global RunMode As Boolean
Global TestMode As Boolean
Global Functional As Boolean
Global TestRecvStarted As Boolean
Global Message As String
Global TimeVal As Integer
Global Quit As Boolean
Global FastInit As Boolean
Global PulseFast As Boolean
Global PulseFastAmount As Integer
Global CustomTesterPresent As Boolean
Global TesterPresent As Boolean
Global VoltageSelection As Integer
Global VoltageSelectionChanged As Boolean
Global Loaded As Boolean
Global Selected_Message As Integer
Global Tester_Present_Message As Integer
Global Number_of_Messages As Integer
Global Source_Address As Integer
Global Target_Address As Integer
Global SendHeader As String
Global ErrorCode As Byte
Global sStr As String
Global HexNum As Integer
Global inAddText As Boolean
Global HundredMsec As Integer
Global in_Timer2 As Boolean
Global RespRecvd As Boolean
Global Retries As Integer
Global TestChar As Byte
Global SendQuery As Boolean
Global Waiting As Boolean
Global DSRwait As Boolean
Global KeyWord As Long
Global Timestamp As Integer
Global RecvDataStamp As Integer
Global InMiddleOfMessage As Boolean




Public Sub SaveData()
On Error GoTo writeerror
Open App.Path + "\KWP2000.CFG" For Output As #1
On Error GoTo writeerror2
Print #1, fTop.comPort.CommPort
If FastInit = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
Print #1, Selected_Message
Print #1, Source_Address
Print #1, Target_Address
If TesterPresent = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
If CustomTesterPresent = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
Print #1, Tester_Present_Message
Print #1, VoltageSelection
If Functional = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
Print #1, BaudRate
Print #1, InterByteDelay
If AlternateMethod = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
If PulseFast = True Then
    Print #1, "1"
Else
    Print #1, "0"
End If
Print #1, PulseFastAmount
'If CarbInit = True Then
'    Print #1, "1"
'Else
'    Print #1, "0"
'End If
Close #1
Exit Sub
writeerror:
On Error Resume Next
MsgBox "Error opening KWP2000.CFG for writing!"
Exit Sub
writeerror2:
On Error Resume Next
MsgBox "Error writing to KWP2000.CFG!"
Close #1
End Sub
Public Sub Send_Message(SendMessage As String)
Dim i As Integer
Dim j As Integer
Dim x As Integer
x = 0

For i = 1 To Len(SendHeader)
    x = x + Asc(Mid$(SendHeader, i, 1))
    If x >= 256 Then x = x - 256
Next i
'While comPort.OutBufferCount > 0
'    DoEvents
'Wend
While fTop.comPort.CTSHolding = False And Quit = False
    DoEvents
Wend
If Quit = True Then Exit Sub
fTop.comPort.Output = SendHeader
Timestamp = HundredMsec
While ((HundredMsec - Timestamp) < 2) And Quit = False
    DoEvents
Wend
For i = 1 To Len(SendMessage)
    x = x + Asc(Mid$(SendMessage, i, 1))
    If x >= 256 Then x = x - 256
    While fTop.comPort.CTSHolding = False And Quit = False
        DoEvents
    Wend
    If Quit = True Then Exit Sub
    fTop.comPort.Output = Mid$(SendMessage, i, 1)
    For j = 1 To 100
        DoEvents
    Next j
Next i
'While comPort.OutBufferCount > 0
'    DoEvents
'Wend
'While comPort.CTSHolding = False And Quit = False
'    DoEvents
'Wend
'If Quit = True Then Exit Sub
'comPort.Output = SendMessage
'While comPort.OutBufferCount > 0
'    DoEvents
'Wend
While fTop.comPort.CTSHolding = False And Quit = False
    DoEvents
Wend
If Quit = True Then Exit Sub
Timestamp = HundredMsec
While ((HundredMsec - Timestamp) < 2) And Quit = False
    DoEvents
Wend
fTop.comPort.Output = Chr$(x) + Chr$(255 - x)
End Sub

Public Sub GetErrorCode()
Dim i As Integer
Dim j As Integer
Dim x As Integer
ErrorCode = &HFF
If Len(sStr) < 8 Then Exit Sub
For i = Len(sStr) - 7 To 1 Step -1
    If Mid$(sStr, i, 5) = "RESP:" Then
        GoTo gotresp
    End If
Next i
Exit Sub
gotresp:
x = 0
For j = i To Len(sStr) - 2
  x = x + Asc(Mid$(sStr, j, 1))
  If x >= 256 Then x = x - 256
Next j
If x = Asc(Mid$(sStr, Len(sStr) - 1, 1)) Then
    If 255 - x = Asc(Right$(sStr, 1)) Then
        ErrorCode = Asc(Mid$(sStr, i + 5, 1))
    Else
        Add_Text ("Received bad 2nd byte of checksum")
    End If
Else
    Add_Text ("Received bad 1st byte of checksum")
End If
End Sub
Public Sub Wait_for_Response(Interval As Integer)
If Quit = True Then Exit Sub
Timestamp = HundredMsec
Waiting = True
While ((HundredMsec - Timestamp) < Interval) And Quit = False
    DoEvents
Wend
If Quit = True Then Exit Sub
sStr = fTop.comPort.Input
Waiting = False
If Len(sStr) > 7 Then GoTo gotone
'If DispErr = True Then
'    Add_Text ("ISO-14230 Box is Not Responding!")
'End If
RespRecvd = False
Exit Sub
gotone:
RespRecvd = True
End Sub
Public Sub DisplayErrorCode()
Select Case ErrorCode
    Case &H0: Add_Text ("Failed to assert K and L lines low.")
    Case &H1: Add_Text ("Failed to assert K line low.")
    Case &H2: Add_Text ("Failed to assert L line low.")
    Case &H3: Add_Text ("Failed to release K and L lines high.")
    Case &H4: Add_Text ("Failed to release K line high.")
    Case &H5: Add_Text ("Failed to release L line high.")
    Case &H6: Add_Text ("K and L lines are shorted low.")
    Case &H7: Add_Text ("K line is shorted low.")
    Case &H8: Add_Text ("L line is shorted low.")
    Case &H9: Add_Text ("No response received from ECU to initialization.")
    Case &HA: Add_Text ("Improper synchronization byte received.")
    Case &HB: Add_Text ("Improper inverse address byte received.")
    Case &HC: Add_Text ("Improper Start Communications Positive Response received.")
    Case &HD: Add_Text ("Bad Start Communications Positive Response checksum.")
    Case &HE: Add_Text ("K-Line Receive Buffer Overflow!")
    Case &H20: Add_Text ("Received invalid checksum from PC.")
    Case &H21: Add_Text ("Received invalid command from PC.")
    Case &H30: Add_Text ("Receive (from PC to ISO-14230 box) buffer overflow.")
    Case &H31: Add_Text ("Transmit (from ISO-14230 box to PC) buffer overflow.")
    Case &H4F: Add_Text ("ISO-14230 Box status OK.")
    Case &HE0: Add_Text ("FLASH ROM Checksum Error.")
    Case &HFF: Add_Text ("Error communicating with ISO-14230 box.")
    Case Else: Add_Text ("ISO-14230 Box returned error code " + Hex$(ErrorCode) + "H")
End Select
End Sub

Public Sub Add_Text(sStr As String)
Dim pos As Long
inAddText = True
If logging = True Then
    On Error GoTo badsave
    logfilesize = logfilesize + 4 + Len(Time$) + Len(sStr)
    Print #3, Time$ + ": " + sStr
    GoTo donewithsave
badsave:
    On Error Resume Next
    MsgBox "Error Saving to Log File!  Saved " + Format(logfilesize, "#0") + " bytes already.", vbCritical, "Error"
    On Error GoTo badclose
    Close #3
    GoTo donewithsave
badclose:
    On Error Resume Next
    MsgBox "Error closing Log File!", vbCritical, "Error"
    GoTo donewithsave
donewithsave:
End If
On Error GoTo noroom
If Len(fTop.tTerminalWindow.Text) + Len(sStr) + Len(Time$) + 2 + 2 > fTop.tTerminalWindow.MaxLength Then
    GoTo noroom
End If
fTop.tTerminalWindow.Text = fTop.tTerminalWindow.Text + Time$ + ": " + sStr + Chr$(13) + Chr$(10)
fTop.tTerminalWindow.SelStart = Len(fTop.tTerminalWindow.Text)
On Error Resume Next
inAddText = False
Exit Sub
noroom:
pos = Len(fTop.tTerminalWindow.Text) / 8
If pos <= Len(fTop.tTerminalWindow.Text) Then
    fTop.tTerminalWindow.Text = Right$(fTop.tTerminalWindow.Text, (Len(fTop.tTerminalWindow.Text) - pos) + 1)
    fTop.tTerminalWindow.Text = fTop.tTerminalWindow.Text + Time$ + ": " + sStr + Chr$(13) + Chr$(10)
Else
    fTop.tTerminalWindow.Text = Time$ + ": " + sStr + Chr$(13) + Chr$(10)
End If
fTop.tTerminalWindow.SelStart = Len(fTop.tTerminalWindow.Text)
On Error Resume Next
inAddText = False
End Sub

